/**
* High Availability Service (HA) for JOnAS
*
* Copyright (C) 2006 Distributed Systems Lab.
* Universidad Polit??cnica de Madrid (Spain)
* Contact: http://lsd.ls.fi.upm.es/lsd
*
* This library is free software; you can redistribute it and/or
* modify it under the terms of the GNU Lesser General Public
* License as published by the Free Software Foundation; either
* version 2.1 of the License, or any later version.
*
* This library is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
* Lesser General Public License for more details.
*
* You should have received a copy of the GNU Lesser General Public
* License along with this library; if not, write to the Free Software
* Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307
* USA
*
* --------------------------------------------------------------------------
* $Id$
* --------------------------------------------------------------------------
*/

package org.objectweb.jonas.ha;

import org.objectweb.carol.cmi.ha.TimerEventListenerCMI;
import org.objectweb.jonas_timer.TimerEventListener;

/**
 * This class converts between jonas TimerEventListener
 * and CMI TimerEventListenerCMI
 */
public class TimerEventListenerWrp implements TimerEventListener {
    
    private TimerEventListenerCMI tel;

    /**
     * Constructor
     * @param tel
     */
    public TimerEventListenerWrp(TimerEventListenerCMI tel) {
        this.tel = tel;
    }

    public void timeoutExpired(Object arg) {
        tel.timeoutExpired(arg);
    }
}
