/**
* High Availability Service (HA) for JOnAS
*
* Copyright (C) 2006 Distributed Systems Lab.
* Universidad Polit??cnica de Madrid (Spain)
* Contact: http://lsd.ls.fi.upm.es/lsd
*
* This library is free software; you can redistribute it and/or
* modify it under the terms of the GNU Lesser General Public
* License as published by the Free Software Foundation; either
* version 2.1 of the License, or any later version.
*
* This library is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
* Lesser General Public License for more details.
*
* You should have received a copy of the GNU Lesser General Public
* License along with this library; if not, write to the Free Software
* Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307
* USA
*
* --------------------------------------------------------------------------
* $Id$
* --------------------------------------------------------------------------
*/

package org.objectweb.jonas.ha;

import org.objectweb.carol.cmi.ha.TimerEventDlg;
import org.objectweb.carol.cmi.ha.TimerEventListenerCMI;
import org.objectweb.carol.cmi.ha.TimerManagerDlg;
import org.objectweb.jonas_timer.TimerManager;

/**
 * Delegate Class for TimerManagerDlg
 */
public class TimerManagerDlgImpl implements TimerManagerDlg {
    
    private static TimerManagerDlg instance;
    
    public static TimerManagerDlg getInstance() {
        if (instance == null) {
            instance = new TimerManagerDlgImpl();
        }
        return instance;
    }

    public TimerEventDlg addTimerMs(TimerEventListenerCMI tel, long timeout, Object arg, boolean permanent) {
        
        TimerEventListenerWrp telw = new TimerEventListenerWrp(tel);
        
        TimerManager.getInstance().addTimerMs(telw, timeout, arg, permanent);
        
        return null;
    }

}
