/**
 * JOnAS: Java(TM) Open Application Server
 * Copyright (C) 2006 Bull S.A.
 * Contact: jonas-team@objectweb.org
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
 * USA
 *
 * --------------------------------------------------------------------------
 * $Id:  $
 * --------------------------------------------------------------------------
 */
package org.objectweb.jonas.management.cluster;

import org.objectweb.jonas.management.monitoring.ServerProxy;


/**
 * A SessionMember represents a JOnAS server using web container Tomcat which is a memeber of a
 * Tomcat cluster for session replication.
 * @author Philippe Durieux
 */
public class TomcatClusterMember extends ClusterMember implements TomcatClusterMemberMBean {
    
    /**
     * tcp listener address
     */
    private String tcpListenAddress = null;
    
    /**
     * tcp listener port
     */
    private int tcpListenPort;

    /**
     * Constructor
     * @param name memberName generated by the SessionCluster
     */
    public TomcatClusterMember(String name, ServerProxy proxy) {
        super(name, proxy);
    }


    /**
     * @return tcp listener address
     */
    public String getTcpListenAddress() {
        return tcpListenAddress;
    }
    public void setTcpListenAddress(String tcpListenAddress) {
        this.tcpListenAddress = tcpListenAddress;
    }
    
    /**
    *
    * @return tcp listener port
    */
    public int getTcpListenPort() {
        return tcpListenPort;
    }
    public void setTcpListenPort(int tcpListenPort) {
        this.tcpListenPort = tcpListenPort;
    }
}