/**
 * JOnAS: Java(TM) Open Application Server
 * Copyright (C) 2005 Bull S.A.
 * Contact: jonas-team@objectweb.org
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
 * USA
 *
 * --------------------------------------------------------------------------
 * $Id: ApplyJonasServerAction.java 9353 2006-08-03 15:37:19Z danesa $
 * --------------------------------------------------------------------------
 */

package org.objectweb.jonas.webapp.jonasadmin.domain;

import java.io.IOException;

import javax.management.ObjectName;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionForward;
import org.apache.struts.action.ActionMapping;
import org.objectweb.jonas.jmx.J2eeObjectName;
import org.objectweb.jonas.jmx.JonasManagementRepr;
import org.objectweb.jonas.jmx.JonasObjectName;
import org.objectweb.jonas.webapp.jonasadmin.JonasBaseAction;

/**
 * @author Adriana Danes
 */

public class ApplyJonasServerAction extends JonasBaseAction {

// --------------------------------------------------------- Public Methods
    public ActionForward executeAction(ActionMapping p_Mapping, ActionForm p_Form
            , HttpServletRequest p_Request, HttpServletResponse p_Response)
    throws IOException, ServletException {

        // Form used
        NewServerForm oForm = (NewServerForm) p_Form;

        // Actions
        try {
            // Construct the ObjectName of the Logical cluster to which the server has to be added
        	String clusterName = (String) m_Session.getAttribute("currentCluster");
        	String clusterType = "LogicalCluster";
            ObjectName on = JonasObjectName.cluster(clusterName, clusterType);

            String[] signature = {"java.lang.String", "[Ljava.lang.String;", "java.lang.String"};
            Object[] params = new Object[3];
            // server name
            params[0] = oForm.getServerName();
            // server's connection URL
            String[] urls = new String[1];
            urls[0] = oForm.getServerURL();
            params[1] = urls;
            // server's cluster daemon
            params[2] = oForm.getServerCld();
            System.out.println("Invoke add server on " + on + " with params:");
            System.out.println("- server name = " + params[0]);
            System.out.println("- server url = " + urls[0]);
            System.out.println("- cluster daemon = " + params[2]);
            JonasManagementRepr.invoke(on, "addServer", params, signature);
        } catch (Throwable t) {
            addGlobalError(t);
            saveErrors(p_Request, m_Errors);
            return (p_Mapping.findForward("Global Error"));
        }

        // Forward to the connector display page or the list if create
        return p_Mapping.findForward("ActionEditDomain");
    }
}