package org.objectweb.jonas.webapp.jonasadmin.monitoring;

import java.io.IOException;
import java.util.Hashtable;
import java.util.Map;

import javax.management.ObjectName;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionForward;
import org.apache.struts.action.ActionMapping;
import org.objectweb.jonas.jmx.JonasManagementRepr;
import org.objectweb.jonas.webapp.jonasadmin.JonasBaseAction;
import org.objectweb.jonas.webapp.jonasadmin.WhereAreYou;

public class CmiClusterAction extends JonasBaseAction {

	public ActionForward executeAction(ActionMapping p_Mapping,
			ActionForm p_Form, HttpServletRequest p_Request,
			HttpServletResponse p_Response) throws IOException,
			ServletException {
		// Form used
		WhereAreYou oWhere = (WhereAreYou) p_Request.getSession().getAttribute(
				WhereAreYou.SESSION_NAME);
		String sDomainName = oWhere.getCurrentDomainName();

		CmiClusterForm oForm = (CmiClusterForm) p_Form;
		try {

			ObjectName on = new ObjectName(sDomainName + ":type=CmiCluster,name=*");

			try {
				oForm.setCmiRegistryMcastAddr((String) JonasManagementRepr.getAttribute(on,
						"cmiRegistryMcastAddr"));
			} catch (RuntimeException e) {
				// Attibute missing
			}
			try {
				oForm.setCmiRegistryMcastPort((String) JonasManagementRepr.getAttribute(on,
						"cmiRegistryMcastPort"));
			} catch (RuntimeException e) {
				// Attibute missing
			}
			try {
				oForm.setCmiRegistryBytesReceived((int) new Integer(JonasManagementRepr.getAttribute(on,
						"cmiRegistryBytesReceived").toString()).intValue());
			} catch (RuntimeException e) {
				// Attibute missing
			}
			try {
				oForm.setCmiRegistryBytesSent((int) new Integer(JonasManagementRepr.getAttribute(on,
						"cmiRegistryBytesSent").toString()).intValue());
			} catch (RuntimeException e) {
				// Attibute missing
			}
			try {
				oForm.setGlobalRegistry((String) JonasManagementRepr.getAttribute(on,
						"globalRegistry"));
			} catch (RuntimeException e) {
				// Attibute missing
			}

		} catch (Throwable t) {
			addGlobalError(t);
			saveErrors(p_Request, m_Errors);
			return (p_Mapping.findForward("Global Error"));
		}

		// Forward to the jsp.
		return (p_Mapping.findForward("CmiCluster"));
	}
}
