package org.objectweb.jonas.webapp.jonasadmin.monitoring;

import java.io.IOException;
import java.util.Hashtable;
import java.util.Iterator;
import java.util.Map;

import javax.management.ObjectName;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionForward;
import org.apache.struts.action.ActionMapping;
import org.objectweb.jonas.jmx.J2eeObjectName;
import org.objectweb.jonas.jmx.JonasManagementRepr;
import org.objectweb.jonas.webapp.jonasadmin.JonasAdminJmx;
import org.objectweb.jonas.webapp.jonasadmin.JonasBaseAction;
import org.objectweb.jonas.webapp.jonasadmin.WhereAreYou;

public class DisplayNodeInfoAction extends JonasBaseAction {

    public ActionForward executeAction(ActionMapping p_Mapping,
            ActionForm p_Form, HttpServletRequest p_Request,
            HttpServletResponse p_Response) throws IOException,
            ServletException {
        // Form used
        WhereAreYou oWhere = (WhereAreYou) p_Request.getSession().getAttribute(
                WhereAreYou.SESSION_NAME);
        String sDomainName = oWhere.getCurrentDomainName();

        NodeInfoForm oForm = (NodeInfoForm) p_Form;
        try {

            /*
             * Server related info
             */
            oForm.setServerName(p_Request.getParameter("node"));

            ObjectName on = new ObjectName(sDomainName
                    + ":type=ServerProxy,name=" + oForm.getServerName());
            try {
                oForm.setState((String) JonasManagementRepr.getAttribute(on,
                        "State"));
            } catch (RuntimeException e) {
                // Attibute missing
            }
            try {
                oForm.setHostName((String) JonasManagementRepr.getAttribute(on,
                        "HostName"));
            } catch (RuntimeException e) {
                // Attibute missing
            }
            try {
                oForm.setAllThreadsCount((int) new Integer(JonasManagementRepr.getAttribute(on,
                        "AllThreadsCount").toString()).intValue());
            } catch (RuntimeException e) {
                // Attibute missing
            }
            try {
                oForm.setJavaVersion((String) JonasManagementRepr.getAttribute(on,
                        "JavaVersion"));
            } catch (RuntimeException e) {
                // Attibute missing
            }
            try {
                oForm.setJavaVendor((String) JonasManagementRepr.getAttribute(on,
                        "JavaVendor"));
            } catch (RuntimeException e) {
                // Attibute missing
            }
            try {
                oForm.setCurrentTotalMemory((int) new Integer(JonasManagementRepr.getAttribute(on,
                        "CurrentTotalMemory").toString())
                        .intValue());
            } catch (RuntimeException e) {
                // Attibute missing
            }
            try {
                oForm.setCurrentUsedMemory((int) new Integer(JonasManagementRepr.getAttribute(on,
                        "CurrentUsedMemory").toString()).intValue());
            } catch (RuntimeException e) {
                // Attibute missing
            }
            try {
                oForm.setJOnASVersion((String) JonasManagementRepr.getAttribute(on,
                        "JOnASVersion"));
            } catch (RuntimeException e) {
                // Attibute missing
            }
            try {
                oForm.setProtocols((String) JonasManagementRepr.getAttribute(on,
                        "Protocols"));
            } catch (RuntimeException e) {
                // Attibute missing
            }
            /*
             * JDK5
             */

            /*
             * Tomcat
             */
            try {
                oForm.setMaxThreadsByConnectorTomcat((int) new Integer(JonasManagementRepr.getAttribute(on,
                        "MaxThreadsByConnectorTomcat").toString()).intValue());
            } catch (RuntimeException e) {
                // Attibute missing
            }
            try {
                oForm.setCurrentThreadCountByConnectorTomcat((int) new Integer(JonasManagementRepr.getAttribute(on,
                        "CurrentThreadCountByConnectorTomcat").toString()).intValue());
            } catch (RuntimeException e) {
                // Attibute missing
            }
            try {
                oForm.setCurrentThreadBusyByConnectorTomcat((int) new Integer(JonasManagementRepr.getAttribute(on,
                        "CurrentThreadBusyByConnectorTomcat").toString()).intValue());
            } catch (RuntimeException e) {
                // Attibute missing
            }
            try {
                oForm.setBytesReceivedByConnectorTomcat(((Long) JonasManagementRepr.getAttribute(on,
                        "BytesReceivedByConnectorTomcat")).longValue());
            } catch (RuntimeException e) {
                // Attibute missing
            }
            try {
                oForm.setBytesSentByConnectorTomcat((int) new Integer(JonasManagementRepr.getAttribute(on,
                        "BytesSentByConnectorTomcat").toString()).intValue());
            } catch (RuntimeException e) {
                // Attibute missing
            }
            try {
                oForm.setErrorCountByConnectorTomcat((int) new Integer(JonasManagementRepr.getAttribute(on,
                        "ErrorCountByConnectorTomcat").toString()).intValue());
            } catch (RuntimeException e) {
                // Attibute missing
            }
            try {
                oForm.setProcessingTimeByConnectorTomcat((int) new Integer(JonasManagementRepr.getAttribute(on,
                        "ProcessingTimeByConnectorTomcat").toString()).intValue());
            } catch (RuntimeException e) {
                // Attibute missing
            }
            try {
                oForm.setRequestCountByConnectorTomcat((int) new Integer(JonasManagementRepr.getAttribute(on,
                        "RequestCountByConnectorTomcat").toString()).intValue());
            } catch (RuntimeException e) {
                // Attibute missing
            }
            /*
             * Tx
             */
            try {
                oForm.setTotalBegunTransactions((int) new Integer(JonasManagementRepr.getAttribute(on,
                        "TotalBegunTransactions").toString()).intValue());
            } catch (RuntimeException e) {
                // Attibute missing
            }
            try {
                oForm.setTotalCommittedTransactions((int) new Integer(JonasManagementRepr.getAttribute(on,
                        "TotalCommittedTransactions").toString()).intValue());
            } catch (RuntimeException e) {
                // Attibute missing
            }
            try {
                oForm.setTotalCurrentTransactions((int) new Integer(JonasManagementRepr.getAttribute(on,
                        "TotalCurrentTransactions").toString()).intValue());
            } catch (RuntimeException e) {
                // Attibute missing
            }
            try {
                oForm.setTotalExpiredTransactions((int) new Integer(JonasManagementRepr.getAttribute(on,
                        "TotalExpiredTransactions").toString()).intValue());
            } catch (RuntimeException e) {
                // Attibute missing
            }
            try {
                oForm.setTotalRolledbackTransactions((int) new Integer(JonasManagementRepr.getAttribute(on,
                        "TotalRolledbackTransactions").toString()).intValue());
            } catch (RuntimeException e) {
                // Attibute missing
            }
            /*
             * Worker Pool
             */
            try {
                oForm.setCurrentWorkerPoolSize((int) new Integer(JonasManagementRepr.getAttribute(on,
                        "CurrentWorkerPoolSize").toString()).intValue());
            } catch (RuntimeException e) {
                // Attibute missing
            }
            try {
                oForm.setMaxWorkerPoolSize((int) new Integer(JonasManagementRepr.getAttribute(on,
                        "MaxWorkerPoolSize").toString()).intValue());
            } catch (RuntimeException e) {
                // Attibute missing
            }
            try {
                oForm.setMinWorkerPoolSize((int) new Integer(JonasManagementRepr.getAttribute(on,
                        "MinWorkerPoolSize").toString()).intValue());
            } catch (RuntimeException e) {
                // Attibute missing
            }
            /*
             * JCA
             */
            try {
                oForm.setBusyMaxJCAConnection((int) new Integer(JonasManagementRepr.getAttribute(on,
                        "BusyMaxJCAConnection").toString()).intValue());
            } catch (RuntimeException e) {
                // Attibute missing
            }
            try {
                oForm.setBusyMinJCAConnection((int) new Integer(JonasManagementRepr.getAttribute(on,
                        "BusyMinJCAConnection").toString()).intValue());
            } catch (RuntimeException e) {
                // Attibute missing
            }
            try {
                oForm.setConnectionFailuresJCAConnection((int) new Integer(JonasManagementRepr.getAttribute(on,
                        "ConnectionFailuresJCAConnection").toString()).intValue());
            } catch (RuntimeException e) {
                // Attibute missing
            }
            try {
                oForm.setConnectionLeaksJCAConnection((int) new Integer(JonasManagementRepr.getAttribute(on,
                        "ConnectionLeaksJCAConnection").toString()).intValue());
            } catch (RuntimeException e) {
                // Attibute missing
            }
            try {
                oForm.setCurrentBusyJCAConnection((int) new Integer(JonasManagementRepr.getAttribute(on,
                        "CurrentBusyJCAConnection").toString()).intValue());
            } catch (RuntimeException e) {
                // Attibute missing
            }
            try {
                oForm.setCurrentInTxJCAConnection((int) new Integer(JonasManagementRepr.getAttribute(on,
                        "CurrentInTxJCAConnection").toString()).intValue());
            } catch (RuntimeException e) {
                // Attibute missing
            }
            try {
                oForm.setCurrentOpenedJCAConnection((int) new Integer(JonasManagementRepr.getAttribute(on,
                        "CurrentOpenedJCAConnection").toString()).intValue());
            } catch (RuntimeException e) {
                // Attibute missing
            }
            try {
                oForm.setCurrentWaitersJCAConnection((int) new Integer(JonasManagementRepr.getAttribute(on,
                        "CurrentWaitersJCAConnection").toString()).intValue());
            } catch (RuntimeException e) {
                // Attibute missing
            }
            try {
                oForm.setInitPoolSizeJCAConnection((int) new Integer(JonasManagementRepr.getAttribute(on,
                        "InitPoolSizeJCAConnection").toString()).intValue());
            } catch (RuntimeException e) {
                // Attibute missing
            }
            try {
                oForm.setPoolMaxSizeJCAConnection((int) new Integer(JonasManagementRepr.getAttribute(on,
                        "PoolMaxSizeJCAConnection").toString()).intValue());
            } catch (RuntimeException e) {
                // Attibute missing
            }
            try {
                oForm.setPoolMinSizeJCAConnection((int) new Integer(JonasManagementRepr.getAttribute(on,
                        "PoolMinSizeJCAConnection").toString()).intValue());
            } catch (RuntimeException e) {
                // Attibute missing
            }
            try {
                oForm.setPoolMaxWaitersJCAConnection((int) new Integer(JonasManagementRepr.getAttribute(on,
                        "PoolMaxWaitersJCAConnection").toString()).intValue());
            } catch (RuntimeException e) {
                // Attibute missing
            }
            try {
                oForm.setPoolMaxWaitTimeJCAConnection((int) new Integer(JonasManagementRepr.getAttribute(on,
                        "PoolMaxWaitTimeJCAConnection").toString()).intValue());
            } catch (RuntimeException e) {
                // Attibute missing
            }
            try {
                oForm.setPoolMaxOpentimeJCAConnection((int) new Integer(JonasManagementRepr.getAttribute(on,
                        "PoolMaxOpentimeJCAConnection").toString()).intValue());
            } catch (RuntimeException e) {
                // Attibute missing
            }
            try {
                oForm.setPhysicalConnectionOpenedCountJCAConnection((int) new Integer(JonasManagementRepr.getAttribute(on,
                        "PhysicalConnectionOpenedCountJCAConnection").toString()).intValue());
            } catch (RuntimeException e) {
                // Attibute missing
            }
            try {
                oForm.setPstmtMaxJCAConnection((int) new Integer(JonasManagementRepr.getAttribute(on,
                        "PstmtMaxJCAConnection").toString()).intValue());
            } catch (RuntimeException e) {
                // Attibute missing
            }
            try {
                oForm.setRejectedFullJCAConnection((int) new Integer(JonasManagementRepr.getAttribute(on,
                        "RejectedFullJCAConnection").toString()).intValue());
            } catch (RuntimeException e) {
                // Attibute missing
            }
            try {
                oForm.setRejectedOpenJCAConnection((int) new Integer(JonasManagementRepr.getAttribute(on,
                        "RejectedOpenJCAConnection").toString()).intValue());
            } catch (RuntimeException e) {
                // Attibute missing
            }
            try {
                oForm.setRejectedOtherJCAConnection((int) new Integer(JonasManagementRepr.getAttribute(on,
                        "RejectedOtherJCAConnection").toString()).intValue());
            } catch (RuntimeException e) {
                // Attibute missing
            }
            try {
                oForm.setRejectedTimeoutJCAConnection((int) new Integer(JonasManagementRepr.getAttribute(on,
                        "RejectedTimeoutJCAConnection").toString()).intValue());
            } catch (RuntimeException e) {
                // Attibute missing
            }
            try {
                oForm.setXaServedOpenJCAConnection((int) new Integer(JonasManagementRepr.getAttribute(on,
                        "XaServedOpenJCAConnection").toString()).intValue());
            } catch (RuntimeException e) {
                // Attibute missing
            }
            try {
                oForm.setWaiterCountJCAConnection((int) new Integer(JonasManagementRepr.getAttribute(on,
                        "WaiterCountJCAConnection").toString()).intValue());
            } catch (RuntimeException e) {
                // Attibute missing
            }
            try {
                oForm.setWaitersHighJCAConnection((int) new Integer(JonasManagementRepr.getAttribute(on,
                        "WaitersHighJCAConnection").toString()).intValue());
            } catch (RuntimeException e) {
                // Attibute missing
            }
            try {
                oForm.setWaitersHighRecentJCAConnection((int) new Integer(JonasManagementRepr.getAttribute(on,
                        "WaitersHighRecentJCAConnection").toString()).intValue());
            } catch (RuntimeException e) {
                // Attibute missing
            }
            try {
                oForm.setWaitingHighJCAConnection((int) new Integer(JonasManagementRepr.getAttribute(on,
                        "WaitingHighJCAConnection").toString()).intValue());
            } catch (RuntimeException e) {
                // Attibute missing
            }
            try {
                oForm.setWaitingHighRecentJCAConnection((int) new Integer(JonasManagementRepr.getAttribute(on,
                        "WaitingHighRecentJCAConnection").toString()).intValue());
            } catch (RuntimeException e) {
                // Attibute missing
            }
            try {
                oForm.setWaitingTimeJCAConnection((int) new Integer(JonasManagementRepr.getAttribute(on,
                        "WaitingTimeJCAConnection").toString()).intValue());
            } catch (RuntimeException e) {
                // Attibute missing
            }
            /*
             * JMS
             */
            try {
                oForm.setJmsQueuesNbMsgsReceiveSinceCreation((int) new Integer(JonasManagementRepr.getAttribute(on,
                        "JmsQueuesNbMsgsReceiveSinceCreation").toString()).intValue());
            } catch (RuntimeException e) {
                // Attibute missing
            }
            try {
                oForm.setJmsQueuesNbMsgsSendToDMQSinceCreation((int) new Integer(JonasManagementRepr.getAttribute(on,
                        "JmsQueuesNbMsgsSendToDMQSinceCreation").toString()).intValue());
            } catch (RuntimeException e) {
                // Attibute missing
            }
            try {
                oForm.setJmsQueuesNbMsgsDeliverSinceCreation((int) new Integer(JonasManagementRepr.getAttribute(on,
                        "JmsQueuesNbMsgsDeliverSinceCreation").toString()).intValue());
            } catch (RuntimeException e) {
                // Attibute missing
            }
            try {
                oForm.setJmsTopicsNbMsgsReceiveSinceCreation((int) new Integer(JonasManagementRepr.getAttribute(on,
                        "JmsTopicsNbMsgsReceiveSinceCreation").toString()).intValue());
            } catch (RuntimeException e) {
                // Attibute missing
            }
            try {
                oForm.setJmsTopicsNbMsgsSendToDMQSinceCreation((int) new Integer(JonasManagementRepr.getAttribute(on,
                        "JmsTopicsNbMsgsSendToDMQSinceCreation").toString()).intValue());
            } catch (RuntimeException e) {
                // Attibute missing
            }
            try {
                oForm.setJmsTopicsNbMsgsDeliverSinceCreation((int) new Integer(JonasManagementRepr.getAttribute(on,
                        "JmsTopicsNbMsgsDeliverSinceCreation").toString()).intValue());
            } catch (RuntimeException e) {
                // Attibute missing
            }
            /*
             * EJB
             */
            try {
                oForm.setCurrentNumberOfBMP((int) new Integer(JonasManagementRepr.getAttribute(on,
                        "CurrentNumberOfBMP").toString()).intValue());
            } catch (RuntimeException e) {
                // Attibute missing
            }
            try {
                oForm.setCurrentNumberOfCMP((int) new Integer(JonasManagementRepr.getAttribute(on,
                        "CurrentNumberOfCMP").toString()).intValue());
            } catch (RuntimeException e) {
                // Attibute missing
            }
            try {
                oForm.setCurrentNumberOfEJB((int) new Integer(JonasManagementRepr.getAttribute(on,
                        "CurrentNumberOfEJB").toString()).intValue());
            } catch (RuntimeException e) {
                // Attibute missing
            }
            try {
                oForm.setCurrentNumberOfMDB((int) new Integer(JonasManagementRepr.getAttribute(on,
                        "CurrentNumberOfMDB").toString()).intValue());
            } catch (RuntimeException e) {
                // Attibute missing
            }
            try {
                oForm.setCurrentNumberOfSBF((int) new Integer(JonasManagementRepr.getAttribute(on,
                        "CurrentNumberOfSBF").toString()).intValue());
            } catch (RuntimeException e) {
                // Attibute missing
            }
            try {
                oForm.setCurrentNumberOfSBL((int) new Integer(JonasManagementRepr.getAttribute(on,
                        "CurrentNumberOfSBL").toString()).intValue());
            } catch (RuntimeException e) {
                // Attibute missing
            }
            try {
                oForm.setCurrentNumberOfEBInMemory((int) new Integer(JonasManagementRepr.getAttribute(on,
                        "CurrentNumberOfEBInMemory").toString()).intValue());
            } catch (RuntimeException e) {
                // Attibute missing
            }
            try {
                oForm.setMaxNumberOfEBInMemory((int) new Integer(JonasManagementRepr.getAttribute(on,
                        "MaxNumberOfEBInMemory").toString()).intValue());
            } catch (RuntimeException e) {
                // Attibute missing
            }
            try {
                oForm.setMinPoolSizeEB((int) new Integer(JonasManagementRepr.getAttribute(on,
                        "MinPoolSizeEB").toString()).intValue());
            } catch (RuntimeException e) {
                // Attibute missing
            }
            try {
                oForm.setPoolSizeEB((int) new Integer(JonasManagementRepr.getAttribute(on,
                        "PoolSizeEB").toString()).intValue());
            } catch (RuntimeException e) {
                // Attibute missing
            }
            try {
                oForm.setCurrentNumberOfSBFInMemory((int) new Integer(JonasManagementRepr.getAttribute(on,
                        "CurrentNumberOfSBFInMemory").toString()).intValue());
            } catch (RuntimeException e) {
                // Attibute missing
            }
            try {
                oForm.setMaxNumberOfSBFInMemory((int) new Integer(JonasManagementRepr.getAttribute(on,
                        "MaxNumberOfSBFInMemory").toString()).intValue());
            } catch (RuntimeException e) {
                // Attibute missing
            }
            try {
                oForm.setMinPoolSizeSBF((int) new Integer(JonasManagementRepr.getAttribute(on,
                        "MinPoolSizeSBF").toString()).intValue());
            } catch (RuntimeException e) {
                // Attibute missing
            }
            try {
                oForm.setPoolSizeSBF((int) new Integer(JonasManagementRepr.getAttribute(on,
                        "PoolSizeSBF").toString()).intValue());
            } catch (RuntimeException e) {
                // Attibute missing
            }
            try {
                oForm.setCurrentNumberOfSBLInMemory((int) new Integer(JonasManagementRepr.getAttribute(on,
                        "CurrentNumberOfSBLInMemory").toString()).intValue());
            } catch (RuntimeException e) {
                // Attibute missing
            }
            try {
                oForm.setMaxNumberOfSBLInMemory((int) new Integer(JonasManagementRepr.getAttribute(on,
                        "MaxNumberOfSBLInMemory").toString()).intValue());
            } catch (RuntimeException e) {
                // Attibute missing
            }
            try {
                oForm.setMinPoolSizeSBL((int) new Integer(JonasManagementRepr.getAttribute(on,
                        "MinPoolSizeSBL").toString()).intValue());
            } catch (RuntimeException e) {
                // Attibute missing
            }
            try {
                oForm.setPoolSizeSBL((int) new Integer(JonasManagementRepr.getAttribute(on,
                        "PoolSizeSBL").toString()).intValue());
            } catch (RuntimeException e) {
                // Attibute missing
            }

        } catch (Throwable t) {
            addGlobalError(t);
            saveErrors(p_Request, m_Errors);
            return (p_Mapping.findForward("Global Error"));
        }

        // Forward to the jsp.
        return (p_Mapping.findForward("DisplayNode"));
    }
}
