package org.objectweb.jonas.webapp.jonasadmin.monitoring;

import java.io.IOException;

import javax.management.ObjectName;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionForward;
import org.apache.struts.action.ActionMapping;
import org.objectweb.jonas.jmx.JonasManagementRepr;
import org.objectweb.jonas.webapp.jonasadmin.JonasBaseAction;
import org.objectweb.jonas.webapp.jonasadmin.WhereAreYou;

public class EjbHaClusterAction extends JonasBaseAction {

	public ActionForward executeAction(ActionMapping p_Mapping,
			ActionForm p_Form, HttpServletRequest p_Request,
			HttpServletResponse p_Response) throws IOException,
			ServletException {
		// Form used
		WhereAreYou oWhere = (WhereAreYou) p_Request.getSession().getAttribute(
				WhereAreYou.SESSION_NAME);
		String sDomainName = oWhere.getCurrentDomainName();

		EjbHaClusterForm oForm = (EjbHaClusterForm) p_Form;
		try {

			ObjectName on = new ObjectName(sDomainName
					+ ":type=EjbHaCluster,*");

			try {
				oForm.setEjbHaMcastAddr((String) JonasManagementRepr.getAttribute(on,
						"ejbHaMcastAddr"));
			} catch (RuntimeException e) {
				// Attibute missing
			}
			try {
				oForm.setEjbHaMcastPort((String) JonasManagementRepr.getAttribute(on,
						"ejbHaMcastPort"));
			} catch (RuntimeException e) {
				// Attibute missing
			}
			try {
				oForm.setEjbHaBytesReceived((int) new Integer(JonasManagementRepr.getAttribute(on,
						"ejbHaBytesReceived").toString()).intValue());
			} catch (RuntimeException e) {
				// Attibute missing
			}
			try {
				oForm.setEjbHaBytesSent((int) new Integer(JonasManagementRepr.getAttribute(on,
						"ejbHaBytesSent").toString()).intValue());
			} catch (RuntimeException e) {
				// Attibute missing
			}

		} catch (Throwable t) {
			addGlobalError(t);
			saveErrors(p_Request, m_Errors);
			return (p_Mapping.findForward("Global Error"));
		}

		// Forward to the jsp.
		return (p_Mapping.findForward("EjbHaCluster"));
	}
}
